From be38236f38f17410957dd21d68e77ec54cfde950 Mon Sep 17 00:00:00 2001
From: Markus Hitter <mah@jump-ing.de>
Date: Mon, 3 Sep 2012 01:05:50 +0200
Subject: [PATCH 2/3] ACCELERATION_SPLIT: make sure the queue has always
 enough free slots.

---
 dda_queue.c |   11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

diff --git a/dda_queue.c b/dda_queue.c
index 889012a..b2adb65 100644
--- a/dda_queue.c
+++ b/dda_queue.c
@@ -36,13 +36,20 @@ uint8_t	mb_tail = 0;
 DDA movebuffer[MOVEBUFFER_SIZE] __attribute__ ((__section__ (".bss")));
 
 /// check if the queue is completely full
+/// ACCELERATION_SPLIT: it's full when less than 5 slots are available
 uint8_t queue_full() {
+	#ifdef ACCELERATION_SPLIT
+		#define SLOTS 5
+	#else
+		#define SLOTS 0
+	#endif
 	MEMORY_BARRIER();
 	if (mb_tail > mb_head) {
-		return ((mb_tail - mb_head - 1) == 0) ? 255 : 0;
+		return ((mb_tail - mb_head - 1 - SLOTS) >= 0) ? 255 : 0;
 	} else {
-		return ((mb_tail + MOVEBUFFER_SIZE - mb_head - 1) == 0) ? 255 : 0;
+		return ((mb_tail + MOVEBUFFER_SIZE - mb_head - 1 - SLOTS) >= 0) ? 255 : 0;
 	}
+	#undef SLOTS
 }
 
 /// check if the queue is completely empty
-- 
1.7.9.5

